<?php
/**
 * inputobj_survey_selections.php - Input object code to display the drop-down with all the
 * 											survey names.
 *
 * @author $Author: dtong $
 * @version $Id: inputobj_survey_selections.php,v 1.1 2013/10/21 01:45:26 dtong Exp $
 * @copyright Copyright (c) 2013, Tiller Software Co., Ltd.
*/

class inputobj_survey_selections extends inputobj_base {

	function __construct($data) {
		parent::__construct($data);
	}

	function render() {
		$surveys = $this->_get_survey_list('survey');
		return form_dropdown('_surveyname', $surveys);
	}

	// This was copied from controller/survey/util.php. I know, copying code is bad, but didn't have time to make a library.
	private function _get_survey_list($file_pattern, $title_only=TRUE) {
		$file_match = CMS_TEMPLATEPATH_BUILDER . CMS_TEMPLATE_SURVEY_IDENTIFIER . '/' .
							 $this->CI->config->item('cms_unit_org') . "_{$file_pattern}*.php";
		$files = glob($file_match);
		if ( count($files) <=0 ) {
			$file_match = CMS_TEMPLATEPATH_BUILDER . CMS_TEMPLATE_SURVEY_IDENTIFIER . '/' .
								$this->CI->config->item('cms_fallback_org_name') . "_{$file_pattern}*.php";
			$files = glob($file_match);
		}
		$file_array = array();
		foreach ($files as $filepath) {
			$file = basename($filepath);
			//This is like survey_2.php
			$file_part = osa_str_extract($file, '_', FALSE);
			if ( !$file_part ) {
				return FALSE;
			}
			//This is like survey_2
			$file_part = osa_str_extract($file_part, '.php', TRUE, FALSE);
			if ( !$file_part ) {
				return FALSE;
			}
			//This is like survey
			$file_group = osa_str_extract($file_part, '_', TRUE, FALSE);
			if ( !$file_group ) {
				return FALSE;
			}
			//This is like 2
			$file_number = osa_str_extract($file_part, '_', FALSE, FALSE);
			if ( !$file_number ) {
				return FALSE;
			}
			if ( !array_key_exists($file_group, $file_array) ) {
				@osa_load_template_obj($file_part, TRUE, CMS_TEMPLATE_SURVEY_IDENTIFIER, 'obj');
				$obj = "obj_$file_part";
				if ( !class_exists($obj) ) {
					//We couldn't load the template class
					osa_errorlog(__METHOD__ . ' - failed to load template object.', array($file_pattern, $file_part, $filepath));
					echo osa_ajaxmsg(lang('gen_internalservererror'));
					exit;
				}
				eval("\$config = $obj::get();");
				$file_array[$file_group] = array('title'=>$config->title, 'templates'=>array($file_number=>$file_part));
			}
			else {
				$tmp = $file_array[$file_group]['templates'];
				$tmp[$file_number] = $file_part;
				$file_array[$file_group]['templates'] = $tmp;
			}
		}
		osa_array_natsort($file_array, 'title', TRUE);
		if ( $title_only ) {
			//Just put the title in the array, this is for the drop down selection box
			$tmp_array = array();
			foreach($file_array as $key => $value) {
				$tmpvar = &$value['title'];
				$tmp_array["{$key}_{$tmpvar}"] = $value['title'];
			}
			$file_array = $tmp_array;
		}
		return $file_array;
	}

}